public class FichaTecnicaController {
     
    public List<TablaFichaCategoria> tablasFicha{get;set;}
    public String contentType{get;set;}
    public FichaTecnicaProducto__c fichaProductoRecord{get;set;}
    public String serie;
    public FichaTecnicaController (){
        tablasFicha = FichaTecnicaController.getTablasFichaDocument((String)ApexPages.currentPage().getParameters().get('id'));
        fichaProductoRecord = FichaTecnicaController.getFTProductoDocument((String)ApexPages.currentPage().getParameters().get('id'));
        String ct = (String)ApexPages.currentPage().getParameters().get('f');
        if(ct=='xls'){
            contentType = 'application/x-excel#FichaProducto.xls';
        }
        
    }
    
    @AuraEnabled
    public static User getCurrentProfile(String userId){
        
    User profUser = new User();
    profUser = [Select Id,Name,Profile.Name From User where id  =: userId];
    system.debug('return'+profUser);   
    return profUser;    
        
    }    
    
   
    @AuraEnabled
    public static Boolean getProfileUser(){
        Id idUser = UserInfo.getUserId();
        Boolean activaFunActDsctFP;
        User usr = [Select id,name,profile.name From User Where id =: idUser];
        
        if(usr.profile.name == 'Product Planner TMEX'){
            activaFunActDsctFP = true;
            
        }else{
            activaFunActDsctFP = false;
            
        }
        
        return activaFunActDsctFP;
       
    }
    
    
    @AuraEnabled
    public static Boolean getCFGPersonalizada(){
        return CFGFichaTecnicaProducto__c.getInstance().btnEditar__c;
    }
    
    @AuraEnabled
    public static String getPrimeProfile(){
        String idPrime = [select id,name from profile where name = 'Prime'].id;
        return idPrime;
    }
    
    @AuraEnabled
    public static FichaTecnicaProducto__c  getFTProducto(String idFTP){
        system.debug('id en metodo'+idFTP);
        String userId = UserInfo.getUserId();
        return [
            SELECT 
            Anio__c, Estatus__c, Id, Name, Serie__c, Serie__r.Name, Version__c, OwnerId, Owner.Email, Owner.Phone, 
            Owner.Name, Versions_comparative__c, Comparative_Versions_Added__c,
            (	
                SELECT CodigoModeloVersion__r.NombreVersion__c,TAM_ActivarVersion__c, CodigoModeloVersion__r.Name, Estatus__c, 
                FichaTecnica__c, Id, Name, NombreVersion__c, EFT_TotalPreliminares__c, Orden__c 
                FROM ModelosFichaProducto__r 
                ORDER BY Orden__c
            ),
            (	SELECT Id, SelectionDescription__c, IsActive__c 
             FROM FichaTecnicaSeleccionUsuarios__r WHERE OwnerId=:userId
            )
            FROM FichaTecnicaProducto__c 
            WHERE Id=:idFTP];
    }
    
	 @AuraEnabled
    public static FichaTecnicaProducto__c  getFTProductoDocument(String idFTP){
        String userId = UserInfo.getUserId();
        return [
            SELECT 
            Anio__c, Estatus__c, Id, Name, Serie__c, Serie__r.Name, Version__c, OwnerId, Owner.Email, Owner.Phone, 
            Owner.Name, Versions_comparative__c, Comparative_Versions_Added__c,
            (	
                SELECT CodigoModeloVersion__r.NombreVersion__c, CodigoModeloVersion__r.Name, Estatus__c, 
                FichaTecnica__c, Id, Name, NombreVersion__c, EFT_TotalPreliminares__c, Orden__c 
                FROM ModelosFichaProducto__r WHERE TAM_ActivarVersion__c = true
                ORDER BY Orden__c
            ),
            (	SELECT Id, SelectionDescription__c, IsActive__c 
             FROM FichaTecnicaSeleccionUsuarios__r WHERE OwnerId=:userId
            )
            FROM FichaTecnicaProducto__c 
            WHERE Id=:idFTP];
    }
    
    public static  String obtieneSerie(String idFTP){
        System.debug(idFTP);
        FichaTecnicaProducto__c ftp = FichaTecnicaController.getFTProducto(idFTP);
        if(ftp.Serie__r.Name != null){
            return  ftp.Serie__r.Name;
        }else{
            return   'null';
        }
    }
    
    @AuraEnabled
    public static List<CodigoModeloFichaTecnica__c> getSeries(String idFTP){
        System.debug(idFTP);
        Map<Id,CodigoModeloFichaTecnica__c> mapVersiones = new Map<Id,CodigoModeloFichaTecnica__c>();
        FichaTecnicaProducto__c ftp = FichaTecnicaController.getFTProducto(idFTP);
        Serie__c serie = FichaTecnicaController.getSerie(ftp.Serie__c, ftp.Anio__c);
        
        System.debug(ftp);
        System.debug(ftp.ModelosFichaProducto__r);
        
        if(ftp!=null && ftp.ModelosFichaProducto__r!=null){
            for(CodigoModeloFichaTecnica__c cm : ftp.ModelosFichaProducto__r){
                mapVersiones.put(cm.CodigoModeloVersion__c,cm);
            }
        }
        System.debug('EN getSeries mapVersiones.KeySet(): ' + mapVersiones.KeySet());
        System.debug('EN getSeries mapVersiones.Values(): ' + mapVersiones.Values());
        
        if(serie!=null && serie.Productos__r!=null){
            for(Product2 p : serie.Productos__r){
                System.debug('EN getSeries p.Serie__c0: ' + p.Serie__r.Name + ' p.Anio__c: ' + p.Anio__c + ' NombreVersion__c: ' + p.NombreVersion__c + ' Name: ' + p.Name + ' id: ' + p.id);
                if(!mapVersiones.containsKey(p.Id)){
                    mapVersiones.put(p.Id,new CodigoModeloFichaTecnica__c(
                        FichaTecnica__c = idFTP,
                        CodigoModeloVersion__c = p.Id,
                        CodigoModeloVersion__r = p,
                        Orden__c = 0
                    ));
                }
            }
        }
        System.debug('EN getSeries mapVersiones.KeySet()2: ' + mapVersiones.KeySet());
        System.debug('EN getSeries mapVersiones.Values()2: ' + mapVersiones.Values());
        
        return mapVersiones.values();
    }
    
    @AuraEnabled
    public static List<SeriesComparativeVersions> getSeriesComparative(String idFTP){
        List<SeriesComparativeVersions> retValue = new List<SeriesComparativeVersions>();
        FichaTecnicaProducto__c ftp = FichaTecnicaController.getFTProducto(idFTP);
        Set<String> agregadosSET = new Set<String>();
        if(ftp.Comparative_Versions_Added__c != null){  
            agregadosSET.addAll(ftp.Comparative_Versions_Added__c.split(','));
        }
        System.debug(JSON.serialize(agregadosSET));
        for(CodigoModeloFichaTecnica__c cm : [SELECT Id, Name, CodigoModeloVersion__r.NombreVersion__c, FichaTecnica__r.Serie__r.Name,  
                                              FichaTecnica__r.Estatus__c, FichaTecnica__r.Anio__c, FichaTecnica__r.Version__c
                                              FROM CodigoModeloFichaTecnica__c]){
                                                  retValue.add(new SeriesComparativeVersions(cm, agregadosSET.contains(cm.Name)));
                                              }
        System.debug(retValue);
        return retValue;
    }
    
    @AuraEnabled
    public static Serie__c getSerie(String idSerie, String anio){
        System.debug('EN getSerie idSerie: ' + idSerie + ' ' + anio);
        return [
            SELECT 
            Name, 
            (
                SELECT Id, Name, NombreVersion__c, Serie__c, Serie__r.Name, Anio__c 
                FROM Productos__r WHERE Anio__c =:anio                   
                ORDER BY Name
            )
            FROM Serie__c WHERE Id=:idSerie];
    }
    
    @AuraEnabled
    public static CodigoModeloFichaTecnica__c insertSerie(CodigoModeloFichaTecnica__c item){
        Savepoint sp = Database.setSavepoint();
        System.debug(item);
        try{
            insert item;
            List<EspecificacionFichaTecnica__c> efts = new List<EspecificacionFichaTecnica__c>();
            item = [Select CodigoModeloVersion__r.Serie__c, CodigoModeloVersion__r.Serie__r.Name, CodigoModeloVersion__c, Estatus__c, FichaTecnica__c, Id, Name, NombreVersion__c FROM CodigoModeloFichaTecnica__c WHERE Id =:item.Id];
            
            List<EspecificacionFichaTecnica__c> eftList = new List<EspecificacionFichaTecnica__c>();
            Map<Id,Boolean> idsAtts = new Map<Id,Boolean>();
            for(EspecificacionFichaTecnica__c eft : [Select Id,EspecificacionAtributo__c, NoAplica__c FROM EspecificacionFichaTecnica__c WHERE FichaTecnicaProducto__c =: item.FichaTecnica__c]){
                idsAtts.put(eft.EspecificacionAtributo__c, eft.NoAplica__c);
            }
            
            if(idsAtts.size()==0){
                for(EspecificacionAtributo__c att : [SELECT Id,TAM_CampoCritico__c FROM EspecificacionAtributo__c WHERE Activo__c=true]){
                    idsAtts.put(att.Id,true);
                }
            }
            
            //Nueva modificación
            for(EspecificacionAtributo__c espAtributo : [SELECT Id,TAM_CampoCritico__c FROM EspecificacionAtributo__c WHERE Activo__c=true]){
                EspecificacionFichaTecnica__c itemEspecifiacion = new EspecificacionFichaTecnica__c();
                itemEspecifiacion.CodigoModeloFichaTecnica__c = item.Id;
                itemEspecifiacion.EspecificacionAtributo__c = espAtributo.Id;
                itemEspecifiacion.FichaTecnicaProducto__c			 = item.FichaTecnica__c;
                itemEspecifiacion.Atributo__c = '';
                itemEspecifiacion.NoAplica__c = true;
                if(espAtributo.TAM_CampoCritico__c == true){
                	itemEspecifiacion.TAM_CampoCritico__c = true;
                    itemEspecifiacion.TAM_EstatusCriticalField__c = 'Pendiente Revisión (Planner)';
                }
                efts.add(itemEspecifiacion);
            }
            
            
            /*
            for(Id attId : idsAtts.keySet()){
                efts.add(new EspecificacionFichaTecnica__c(
                    CodigoModeloFichaTecnica__c = item.Id,
                    EspecificacionAtributo__c = attId,
                    FichaTecnicaProducto__c = item.FichaTecnica__c,
                    Atributo__c = '',
                    NoAplica__c = idsAtts.get(attId)
                ));
            }
			*/
            
            if(efts.size()>0){
                insert efts;
            }
        }catch(Exception e){
            System.debug(e.getMessage());
            Database.rollback(sp);
        }
        return item;
    }
    
    @AuraEnabled
    public static CodigoModeloFichaTecnica__c deleteSerie(CodigoModeloFichaTecnica__c item){
        Savepoint sp = Database.setSavepoint();
        try{
            List<EspecificacionFichaTecnica__c> efts = [SELECT Id FROM EspecificacionFichaTecnica__c WHERE CodigoModeloFichaTecnica__c =: item.Id];
            if(efts.size()>0){
                delete efts;
            }
            delete item;
            
        }catch(Exception e){
            System.debug(e.getMessage());
            Database.rollback(sp);
        }
        
        return item;
    }
    
    @AuraEnabled
    public static Id clonarFicha(String idFTP){
        FichaTecnicaProducto__c ftpClon = new FichaTecnicaProducto__c();
        Savepoint sp = Database.setSavepoint();
        try{
            FichaTecnicaProducto__c ftpBase = FichaTecnicaController.getFTProducto(idFTP);
            List<EspecificacionFichaTecnica__c> efts = FichaTecnicaController.getEFT(idFTP);
            
            ftpClon = new FichaTecnicaProducto__c(
                Anio__c = ftpBase.Anio__c,
                Serie__c = ftpBase.Serie__c,
                Version__c = ftpBase.Version__c
            );
            insert ftpClon;
            List<CodigoModeloFichaTecnica__c> modelos = new List<CodigoModeloFichaTecnica__c>(); 
            for(CodigoModeloFichaTecnica__c modelo : ftpBase.ModelosFichaProducto__r){
                modelos.add(new CodigoModeloFichaTecnica__c(
                    FichaTecnica__c = ftpClon.Id,
                    CodigoModeloVersion__c = modelo.CodigoModeloVersion__c
                ));
            }
            insert modelos;
            Map<Id,Id> mapModelos = new Map<Id,Id>();
            for(Integer i = 0 ; i < modelos.size() ; i++){
                mapModelos.put(ftpBase.ModelosFichaProducto__r.get(i).Id,modelos.get(i).Id);
            }
            
            List<EspecificacionFichaTecnica__c> eftsNueva = new List<EspecificacionFichaTecnica__c>(); 
            for(EspecificacionFichaTecnica__c eft : efts){
                eftsNueva.add(new EspecificacionFichaTecnica__c(
                    CodigoModeloFichaTecnica__c = mapModelos.get(eft.CodigoModeloFichaTecnica__c),
                    EspecificacionAtributo__c = eft.EspecificacionAtributo__c,
                    FichaTecnicaProducto__c = ftpClon.Id,
                    Atributo__c = eft.Atributo__c,
                    NoAplica__c = eft.NoAplica__c
                ));
            }
            insert eftsNueva;
            
        }catch(Exception e){
            System.debug(e.getMessage());
            Database.rollback(sp);
        }
        System.debug(ftpClon);
        return ftpClon.Id;
    }
    
    @AuraEnabled
    public static List<EspecificacionFichaTecnica__c> actualizaEFTs(List<EspecificacionFichaTecnica__c> efts){
        system.debug('metodo acutalizar'+efts);
        List<EspecificacionFichaTecnica__c> eftc = [Select id,Atributo__c,EstatusEspecificacion__c,NoAplica__c,TAM_EstatusCriticalField__c,TAM_CampoCritico__c FROM EspecificacionFichaTecnica__c WHERE FichaTecnicaProducto__c =: efts[0].FichaTecnicaProducto__c AND SubgrupoEspecificacion__c =: efts[0].SubgrupoEspecificacion__c AND TipoAtributo__c =: efts[0].TipoAtributo__c order by TipoAtributo__c];
        List<EspecificacionFichaTecnica__c> listUpd = new List<EspecificacionFichaTecnica__c>();
        if(!eftc.isEmpty() & !efts.isEmpty()){
            for(EspecificacionFichaTecnica__c list1 : eftc){
                for(EspecificacionFichaTecnica__c list2 : efts){
                    if(list1.Id == list2.Id && list1.Atributo__c != list2.Atributo__c || list1.EstatusEspecificacion__c != list2.EstatusEspecificacion__c){
                        listUpd.add(list2);
                        
                    }
                    if(list2.NoAplica__c == true || list2.NoAplica__c == false){
                        listUpd.add(list2);
                    }
                }
            }
        }
        List<Id> setIds = new List<Id>();
        for(EspecificacionFichaTecnica__c eft : efts){
            setIds.add(eft.Id);
        }
        map<id,EspecificacionFichaTecnica__c> accmap = new map<id,EspecificacionFichaTecnica__c>();	
        accmap.putall(listUpd);
        update accmap.values();
        List<EspecificacionFichaTecnica__c> ListTempEspecificacionFichaTecnica = new List<EspecificacionFichaTecnica__c>();
        ListTempEspecificacionFichaTecnica = getEFTFila(setIds);
        if(ListTempEspecificacionFichaTecnica.isEmpty()){
            ListTempEspecificacionFichaTecnica =  new List<EspecificacionFichaTecnica__c>();
        }
        system.debug('retorno'+ListTempEspecificacionFichaTecnica);
        return ListTempEspecificacionFichaTecnica;
    }
    
    @AuraEnabled
    public static List<EspecificacionFichaTecnica__c> getEFT(String idFTP){
        return [
            SELECT
            Atributo__c,TAM_CampoCritico__c,TAM_EstatusCriticalField__c,CodigoModeloFichaTecnica__r.TAM_ActivarVersion__c,CodigoModeloFichaTecnica__c, EspecificacionAtributo__c, EstatusEspecificacion__c, 
            EstatusFichaTecnica__c, FichaTecnicaProducto__c, GrupoEspecificacion__c, NoAplica__c, 
            Id, Name, SubgrupoEspecificacion__c, TipoAtributo__c, VersionFichaTecnica__c,
            EspecificacionAtributo__r.Categoria__c, EspecificacionAtributo__r.SubCategoria__c, EspecificacionAtributo__r.TipoEspecificacion__c, EspecificacionAtributo__r.TipoAtributo__c,
            EspecificacionAtributo__r.Opciones__c,
            CodigoModeloFichaTecnica__r.CodigoModeloVersion__r.Name, LastModifiedBy.ProfileId, CodigoModeloFichaTecnica__r.CodigoModeloVersion__r.NombreVersion__c  
            FROM EspecificacionFichaTecnica__c
            WHERE FichaTecnicaProducto__c=:idFTP
            ORDER BY 
            EspecificacionAtributo__r.Orden__c, EspecificacionAtributo__r.Categoria__c, EspecificacionAtributo__r.SubCategoria__c, EspecificacionAtributo__r.TipoEspecificacion__c, EspecificacionAtributo__r.TipoAtributo__c,
            CodigoModeloFichaTecnica__r.Orden__c
        ];
    }
    
    public static List<EspecificacionFichaTecnica__c> getEFTByVersions(List<String> versionsName){
        return [
            SELECT
            Atributo__c,TAM_CampoCritico__c,TAM_EstatusCriticalField__c,CodigoModeloFichaTecnica__r.TAM_ActivarVersion__c, CodigoModeloFichaTecnica__c, EspecificacionAtributo__c, EstatusEspecificacion__c, 
            EstatusFichaTecnica__c, FichaTecnicaProducto__c, GrupoEspecificacion__c, NoAplica__c, 
            Id, Name, SubgrupoEspecificacion__c, TipoAtributo__c, VersionFichaTecnica__c,
            EspecificacionAtributo__r.Categoria__c, EspecificacionAtributo__r.SubCategoria__c, EspecificacionAtributo__r.TipoEspecificacion__c, EspecificacionAtributo__r.TipoAtributo__c,
            EspecificacionAtributo__r.Opciones__c,
            CodigoModeloFichaTecnica__r.CodigoModeloVersion__r.Name, LastModifiedBy.ProfileId, CodigoModeloFichaTecnica__r.CodigoModeloVersion__r.NombreVersion__c  
            FROM EspecificacionFichaTecnica__c
            WHERE CodigoModeloFichaTecnica__r.Name IN:versionsName
            ORDER BY 
            EspecificacionAtributo__r.Orden__c, EspecificacionAtributo__r.Categoria__c, EspecificacionAtributo__r.SubCategoria__c, EspecificacionAtributo__r.TipoEspecificacion__c, EspecificacionAtributo__r.TipoAtributo__c,
            CodigoModeloFichaTecnica__r.Orden__c
        ];
    }
    
    @AuraEnabled
    public static List<EspecificacionFichaTecnica__c> getEFTFila(List<Id> idsFTP){
        return [
            SELECT
            Atributo__c,TAM_CampoCritico__c,TAM_EstatusCriticalField__c,CodigoModeloFichaTecnica__c,CodigoModeloFichaTecnica__r.TAM_ActivarVersion__c, EspecificacionAtributo__c, EstatusEspecificacion__c, 
            EstatusFichaTecnica__c, FichaTecnicaProducto__c, GrupoEspecificacion__c, NoAplica__c,
            Id, Name, SubgrupoEspecificacion__c, TipoAtributo__c, VersionFichaTecnica__c,
            EspecificacionAtributo__r.Categoria__c, EspecificacionAtributo__r.SubCategoria__c, EspecificacionAtributo__r.TipoEspecificacion__c, EspecificacionAtributo__r.TipoAtributo__c,
            EspecificacionAtributo__r.Opciones__c,
            CodigoModeloFichaTecnica__r.CodigoModeloVersion__r.Name, LastModifiedBy.ProfileId, CodigoModeloFichaTecnica__r.CodigoModeloVersion__r.NombreVersion__c  
            FROM EspecificacionFichaTecnica__c
            WHERE Id IN:idsFTP
            ORDER BY 
            EspecificacionAtributo__r.Orden__c, EspecificacionAtributo__r.Categoria__c, EspecificacionAtributo__r.SubCategoria__c, EspecificacionAtributo__r.TipoEspecificacion__c, EspecificacionAtributo__r.TipoAtributo__c,
            CodigoModeloFichaTecnica__r.Orden__c
        ];
    }
    
    @AuraEnabled
    public static Map<String,Boolean> getFTSU(String idFTP){
        String userId = UserInfo.getUserId();
        Map<String,Boolean> resp;
        List<FichaTecnicaSeleccionUsuario__c> ftsuList = [SELECT Id, Seleccion__c FROM FichaTecnicaSeleccionUsuario__c WHERE OwnerId =:userId and FichaTecnicaProducto__c =:idFTP and IsActive__c = true ];
        
        if(ftsuList!=null && ftsuList.size() > 0){
            FichaTecnicaSeleccionUsuario__c ftsu = ftsuList.get(0);
            if(ftsu.Seleccion__c!=null && ftsu.Seleccion__c!=''){
                resp = (Map<String, Boolean>)JSON.deserialize(ftsu.Seleccion__c,Map<String, Boolean>.class);
            }
        }
        return resp;
    }
    
    @AuraEnabled
    public static String setFTSU(String idFTP, String ftsuDescription){
        Set<Id> idsAtts = new Set<Id>();
        String userId = UserInfo.getUserId();
        
        for(EspecificacionFichaTecnica__c item : FichaTecnicaController.getEFT(idFTP)){
            idsAtts.add(item.EspecificacionAtributo__c);
        }
        FichaTecnicaSeleccionUsuario__c ftsu = new FichaTecnicaSeleccionUsuario__c(
            FichaTecnicaProducto__c = idFTP,
            SelectionDescription__c = ftsuDescription, 
            IsActive__c = true            
        );
        Map<String,Boolean> resp = new Map<String,Boolean>();
        for(Id idftsu : idsAtts){
            resp.put(String.valueOf(idftsu),true);
        }
        ftsu.Seleccion__c = JSON.serialize(resp);
        insert ftsu;
        
        List<FichaTecnicaSeleccionUsuario__c> ftsuList = [SELECT Id, Seleccion__c, IsActive__c FROM FichaTecnicaSeleccionUsuario__c WHERE OwnerId =:userId and FichaTecnicaProducto__c =:idFTP and Id !=:ftsu.Id];
        if(ftsuList.size() > 0){
            for(FichaTecnicaSeleccionUsuario__c fts : ftsuList){
                fts.IsActive__c = false;
            }
            
            update ftsuList;
        }
        return 'ok';
    }
    
    @AuraEnabled
    public static String saveFTSU(String idFTP, Map<String,Boolean> seleccion){
        System.debug('saveFTSU');
        String userId = UserInfo.getUserId();
        List<FichaTecnicaSeleccionUsuario__c> ftsuList = [SELECT Id, Seleccion__c FROM FichaTecnicaSeleccionUsuario__c WHERE OwnerId =:userId and FichaTecnicaProducto__c =:idFTP and IsActive__c = true ];
        if(ftsuList!=null && ftsuList.size() > 0){
            FichaTecnicaSeleccionUsuario__c ftsu = ftsuList.get(0);
            ftsu.Seleccion__c = JSON.serialize(seleccion);
            update ftsu;
        }else{
            throw new ToyotaException('Error al guardar: No existe el registro de configuracion');
        }
        return 'ok';
    }
    
    //Metodo que funciona para traer las tablas para el documento pdf y excel
     @AuraEnabled
    public static List<TablaFichaCategoria> getTablasFicha(String idFTP){
        FichaTecnicaProducto__c ft = FichaTecnicaController.getFTProducto(idFTP);
        List<TablaFichaCategoria> tablas = new List<TablaFichaCategoria>();
        Map<String,Boolean> ftsu = FichaTecnicaController.getFTSU(idFTP);
        System.debug('ftsu');
        System.debug(ftsu);
        
        Map<String,Map<String,Map<String,Map<String,List<EspecificacionFichaTecnica__c>>>>> categorias = new Map<String,Map<String,Map<String,Map<String,List<EspecificacionFichaTecnica__c>>>>>();
        List<String> versionsName = ft.Comparative_Versions_Added__c != null ? ft.Comparative_Versions_Added__c.split(','): new List<String>();
        
        List<EspecificacionFichaTecnica__c> especificaciones = ft.Versions_comparative__c ? FichaTecnicaController.getEFTByVersions(versionsName) : FichaTecnicaController.getEFT(idFTP);
        //List<EspecificacionFichaTecnica__c> especificaciones = FichaTecnicaController.getEFT(idFTP);
        for(EspecificacionFichaTecnica__c eft : especificaciones){
            if(eft.EspecificacionAtributo__r!=null){
                if(eft.EstatusFichaTecnica__c=='Final' && eft.NoAplica__c){
                    continue;
                }
                String cat = eft.EspecificacionAtributo__r.Categoria__c==null?'':eft.EspecificacionAtributo__r.Categoria__c;
                String tipoEsp = eft.EspecificacionAtributo__r.TipoEspecificacion__c==null?'':eft.EspecificacionAtributo__r.TipoEspecificacion__c;
                String subCat = eft.EspecificacionAtributo__r.SubCategoria__c==null?'':eft.EspecificacionAtributo__r.SubCategoria__c;
                String tipoAtt = eft.EspecificacionAtributo__r.TipoAtributo__c==null?'':eft.EspecificacionAtributo__r.TipoAtributo__c;
                
                if(!categorias.containsKey(cat)){
                    categorias.put(cat, new Map<String,Map<String,Map<String,List<EspecificacionFichaTecnica__c>>>>());
                }
                if(!categorias.get(cat).containsKey(tipoEsp)){
                    categorias.get(cat).put(tipoEsp, new Map<String,Map<String,List<EspecificacionFichaTecnica__c>>>());
                }
                if(!categorias.get(cat).get(tipoEsp).containsKey(subCat)){
                    categorias.get(cat).get(tipoEsp).put(subCat, new Map<String,List<EspecificacionFichaTecnica__c>>());
                }
                if(!categorias.get(cat).get(tipoEsp).get(subCat).containsKey(tipoAtt)){
                    categorias.get(cat).get(tipoEsp).get(subCat).put(tipoAtt, new List<EspecificacionFichaTecnica__c>());
                }
                categorias.get(cat).get(tipoEsp).get(subCat).get(tipoAtt).add(eft);
            }
        }
        TablaFicha tablasCabeceras = new TablaFicha();
        
        
        List<CodigoModeloFichaTecnica__c> versions = ft.Versions_comparative__c ? [SELECT TAM_ActivarVersion__c,CodigoModeloVersion__r.NombreVersion__c, CodigoModeloVersion__r.Name FROM CodigoModeloFichaTecnica__c WHERE Name IN: versionsName] : ft.ModelosFichaProducto__r;
        for(CodigoModeloFichaTecnica__c cm : versions){
            TablaConfiguracion tc = new TablaConfiguracion();
            tc.etiqueta = cm.CodigoModeloVersion__r.NombreVersion__c;
            tc.modelCode = cm.CodigoModeloVersion__r.Name;
            tablasCabeceras.cabecera.add(tc);
        }
        System.debug(JSON.serialize(categorias));
        system.debug('categorias de ficha'+JSON.serialize(categorias));
        for(String cat : categorias.KeySet()){ // Categoria ET, In o Ext
            TablaFichaCategoria tabla = new TablaFichaCategoria(cat);
            tabla.ftsu = ftsu;
            for(String tipoEsp : categorias.get(cat).keySet()){ //Frenos, Transmision
                TablaFichaCategoria especificacion = new TablaFichaCategoria(tipoEsp);
                
                for(String subcat : categorias.get(cat).get(tipoEsp).keySet()){ // Subcategoria, o blanco
                    TablaFicha fichaSubCat = new TablaFicha();
                    fichaSubCat.cabecera.add(new TablaConfiguracion(subCat));
                    fichaSubCat.cabecera.addAll(tablasCabeceras.cabecera);
                    for(String att : categorias.get(cat).get(tipoEsp).get(subcat).keySet()){//ABS, Traseros
                        TablaConfiguracion atVal = new TablaConfiguracion(att);
                        //atVal.valor = ; // Identificador de la especificacion
                        for(EspecificacionFichaTecnica__c eft : categorias.get(cat).get(tipoEsp).get(subcat).get(att)){
                            atVal.nombreCampo = eft.EspecificacionAtributo__c;
                            atVal.campoCritico = eft.TAM_CampoCritico__c;
                            atVal.estatusCriticalField = eft.TAM_EstatusCriticalField__c;
                            atVal.selecionado = true;
                            atVal.atributos.add(eft);
                            
                            if(ftsu!=null){
                                atVal.valor = 'check';
                                atVal.selecionado = ftsu.containsKey(eft.EspecificacionAtributo__c)?ftsu.get(eft.EspecificacionAtributo__c):false;
                            }
                        }
                        fichaSubCat.filas.add(atVal);
                    }
                    especificacion.tablas.add(fichaSubCat);
                }
                tabla.subcategorias.add(especificacion);
            }	
            tablas.add(tabla);
        }
        System.debug(JSON.serialize(tablas));
        return tablas;
    }
    
    
    @AuraEnabled
    public static List<TablaFichaCategoria> getTablasFichaDocument(String idFTP){
        FichaTecnicaProducto__c ft = FichaTecnicaController.getFTProductoDocument(idFTP);
        List<TablaFichaCategoria> tablas = new List<TablaFichaCategoria>();
        Map<String,Boolean> ftsu = FichaTecnicaController.getFTSU(idFTP);
        System.debug('ftsu');
        System.debug(ftsu);
        
        Map<String,Map<String,Map<String,Map<String,List<EspecificacionFichaTecnica__c>>>>> categorias = new Map<String,Map<String,Map<String,Map<String,List<EspecificacionFichaTecnica__c>>>>>();
        List<String> versionsName = ft.Comparative_Versions_Added__c != null ? ft.Comparative_Versions_Added__c.split(','): new List<String>();
        
        List<EspecificacionFichaTecnica__c> especificaciones = ft.Versions_comparative__c ? FichaTecnicaController.getEFTByVersions(versionsName) : FichaTecnicaController.getEFT(idFTP);
        //List<EspecificacionFichaTecnica__c> especificaciones = FichaTecnicaController.getEFT(idFTP);
        for(EspecificacionFichaTecnica__c eft : especificaciones){
            if(eft.EspecificacionAtributo__r!=null){
                if(eft.EstatusFichaTecnica__c=='Final' && eft.NoAplica__c){
                    continue;
                }
                String cat = eft.EspecificacionAtributo__r.Categoria__c==null?'':eft.EspecificacionAtributo__r.Categoria__c;
                String tipoEsp = eft.EspecificacionAtributo__r.TipoEspecificacion__c==null?'':eft.EspecificacionAtributo__r.TipoEspecificacion__c;
                String subCat = eft.EspecificacionAtributo__r.SubCategoria__c==null?'':eft.EspecificacionAtributo__r.SubCategoria__c;
                String tipoAtt = eft.EspecificacionAtributo__r.TipoAtributo__c==null?'':eft.EspecificacionAtributo__r.TipoAtributo__c;
                
                if(!categorias.containsKey(cat)){
                    categorias.put(cat, new Map<String,Map<String,Map<String,List<EspecificacionFichaTecnica__c>>>>());
                }
                if(!categorias.get(cat).containsKey(tipoEsp)){
                    categorias.get(cat).put(tipoEsp, new Map<String,Map<String,List<EspecificacionFichaTecnica__c>>>());
                }
                if(!categorias.get(cat).get(tipoEsp).containsKey(subCat)){
                    categorias.get(cat).get(tipoEsp).put(subCat, new Map<String,List<EspecificacionFichaTecnica__c>>());
                }
                if(!categorias.get(cat).get(tipoEsp).get(subCat).containsKey(tipoAtt)){
                    categorias.get(cat).get(tipoEsp).get(subCat).put(tipoAtt, new List<EspecificacionFichaTecnica__c>());
                }
                categorias.get(cat).get(tipoEsp).get(subCat).get(tipoAtt).add(eft);
            }
        }
        TablaFicha tablasCabeceras = new TablaFicha();
        
        
        List<CodigoModeloFichaTecnica__c> versions = ft.Versions_comparative__c ? [SELECT TAM_ActivarVersion__c,CodigoModeloVersion__r.NombreVersion__c, CodigoModeloVersion__r.Name FROM CodigoModeloFichaTecnica__c WHERE Name IN: versionsName] : ft.ModelosFichaProducto__r;
        for(CodigoModeloFichaTecnica__c cm : versions){
            TablaConfiguracion tc = new TablaConfiguracion();
            tc.etiqueta = cm.CodigoModeloVersion__r.NombreVersion__c;
            tc.modelCode = cm.CodigoModeloVersion__r.Name;
            tablasCabeceras.cabecera.add(tc);
        }
        System.debug(JSON.serialize(categorias));
        for(String cat : categorias.KeySet()){ // Categoria ET, In o Ext
            TablaFichaCategoria tabla = new TablaFichaCategoria(cat);
            tabla.ftsu = ftsu;
            for(String tipoEsp : categorias.get(cat).keySet()){ //Frenos, Transmision
                TablaFichaCategoria especificacion = new TablaFichaCategoria(tipoEsp);
                
                for(String subcat : categorias.get(cat).get(tipoEsp).keySet()){ // Subcategoria, o blanco
                    TablaFicha fichaSubCat = new TablaFicha();
                    fichaSubCat.cabecera.add(new TablaConfiguracion(subCat));
                    fichaSubCat.cabecera.addAll(tablasCabeceras.cabecera);
                    for(String att : categorias.get(cat).get(tipoEsp).get(subcat).keySet()){//ABS, Traseros
                        TablaConfiguracion atVal = new TablaConfiguracion(att);
                        //atVal.valor = ; // Identificador de la especificacion
                        for(EspecificacionFichaTecnica__c eft : categorias.get(cat).get(tipoEsp).get(subcat).get(att)){
                            atVal.nombreCampo = eft.EspecificacionAtributo__c;
                            atVal.campoCritico = eft.TAM_CampoCritico__c;
                            atVal.selecionado = true;
                            if(eft.CodigoModeloFichaTecnica__r.TAM_ActivarVersion__c == true){
                            	atVal.atributos.add(eft);
                            }
                            
                            if(ftsu!=null){
                                atVal.valor = 'check';
                                atVal.selecionado = ftsu.containsKey(eft.EspecificacionAtributo__c)?ftsu.get(eft.EspecificacionAtributo__c):false;
                            }
                        }
                        fichaSubCat.filas.add(atVal);
                    }
                    especificacion.tablas.add(fichaSubCat);
                }
                tabla.subcategorias.add(especificacion);
            }	
            tablas.add(tabla);
        }
        System.debug(JSON.serialize(tablas));
        return tablas;
    }
    
    @AuraEnabled
    public static void saveSeriesOrder(List<CodigoModeloFichaTecnica__c> series){
        update series;
    }
    
    @AuraEnabled
    public static void saveFTP(String idFTP, String versionsAdded){
        FichaTecnicaProducto__c ftp = new FichaTecnicaProducto__c(
            Id = idFTP,
            Comparative_Versions_Added__c = versionsAdded
        );
        
        update ftp;
    }
    
    @AuraEnabled
    public static String activeFTSU(String idFTP, String idFTSU){
        String userId = UserInfo.getUserId();
        
        List<FichaTecnicaSeleccionUsuario__c> ftsuList = [SELECT Id, Seleccion__c, IsActive__c FROM FichaTecnicaSeleccionUsuario__c WHERE OwnerId =:userId and FichaTecnicaProducto__c =:idFTP];
        if(ftsuList.size() > 0){
            for(FichaTecnicaSeleccionUsuario__c ftsu : ftsuList){
                ftsu.IsActive__c = ftsu.Id == idFTSU ? true : false;
            }            
            update ftsuList;
        }
        return 'ok';
    }
    
    public class TablaFichaCategoria{
        @AuraEnabled public String nombre{get;set;}
        @AuraEnabled public List<TablaFichaCategoria> subcategorias{get;set;}
        @AuraEnabled public List<TablaFicha> tablas{get;set;}
        @AuraEnabled public Map<String,Boolean> ftsu{get;set;}
        @AuraEnabled public Boolean activo{get;set;}
        
        public TablaFichaCategoria(String nombre){
            this();
            this.nombre = nombre;
        }
        public TablaFichaCategoria(){
            this.nombre = '';
            this.subcategorias = new List<TablaFichaCategoria>();
            this.tablas = new List<TablaFicha>();
        }
    }
    
    public class TablaFicha{
        @AuraEnabled public List<TablaConfiguracion> cabecera{get;set;}
        @AuraEnabled public List<TablaConfiguracion> filas{get;set;}
        
        public TablaFicha(){
            this.cabecera = new List<TablaConfiguracion>();
            this.filas = new List<TablaConfiguracion>();
        }
        
        public Boolean getMostrarTablaPDF(){
            Boolean retValue = false;
            Integer noAplicaCounter = 0;
            
            if(filas.size() > 0){
                for(TablaConfiguracion tc: filas){
                    if(tc.getNoAplica()){
                        noAplicaCounter++;
                    }
                }
                
                retValue = noAplicaCounter < filas.size() ? true : retValue;  
            }
            
            return retValue;
        }
    }
    
    public class TablaConfiguracion{
        @AuraEnabled public String etiqueta{get;set;}
        @AuraEnabled public String nombreCampo{get;set;}
        @AuraEnabled public String tipoDato{get;set;}
        @AuraEnabled public String valor{get;set;}
        @AuraEnabled public Boolean selecionado{get;set;}
        @AuraEnabled public String modelCode{get;set;}
        @AuraEnabled public List<EspecificacionFichaTecnica__c> atributos{get;set;}
        @AuraEnabled public String serie1;
        @AuraEnabled public Boolean campoCritico {get;set;}
        @AuraEnabled public String estatusCriticalField {get;set;}
        
        public TablaConfiguracion(String etiqueta){
            this();
            this.etiqueta = etiqueta==null?'':etiqueta;
            this.campoCritico =  campoCritico;
        }
        
        public TablaConfiguracion(String etiqueta, String valor ){
            this(etiqueta);
            this.valor = valor;
        }
        
        public TablaConfiguracion(){
            // serie1 = FichaTecnicaController.obtieneSerie('a0x5B000000Q2IXQA0');
            this.etiqueta = '';
            this.nombreCampo = '';
            this.tipoDato = '';
            this.valor = '';
            //if(ficha.serie != null){
            //	this.modelCode = ficha.serie;    
            //}else{
            this.modelCode = '';
            //}
            this.atributos = new List<EspecificacionFichaTecnica__c>();
        }
        public TablaConfiguracion(EspecificacionFichaTecnica__c item){
            this.etiqueta = item.especificacionAtributo__r.TipoAtributo__c;
            this.campoCritico =  item.especificacionAtributo__r.TAM_CampoCritico__c;
            this.nombreCampo = '';
            this.tipoDato = '';
            this.valor = item.Name;
        }
        
        public Boolean getNoAplica(){
            Boolean retValue = false;
            if(atributos != null && atributos.size() > 0){
                for(EspecificacionFichaTecnica__c eft: atributos){
                    if(eft.NoAplica__c){
                        retValue = true;
                        break;
                    }
                }
            }
            
            return retValue;
        }
        
        @AuraEnabled public Integer getTotalDifferentAttributes(){
            Set<String> atributosSet = new Set<String>();
            if(atributos != null && atributos.size() > 0){
                for(EspecificacionFichaTecnica__c eft: atributos){
                    atributosSet.add(eft.Atributo__c);
                }
            }
            
            return atributosSet.size();
        }
    }
    
    public class SeriesComparativeVersions{
        @AuraEnabled public Boolean isSelected{get;set;}
        @AuraEnabled public CodigoModeloFichaTecnica__c serie{get;set;}
        
        public SeriesComparativeVersions(CodigoModeloFichaTecnica__c serie, Boolean sel){
            this.serie = serie;
            this.isSelected = sel;
        }
    }
    
    public String getCurrentDate(){
        DateTime today = System.now();
        return today.format('dd/MM/yyyy HH:mm:ss','America/Mexico_City');
    }
    
    //Metodo para guardar el pdf generado dentro de salesforce 
    @AuraEnabled
    public static void savePdfSFDC(String id){
        //Se crea el registro de tipo TAM_SeguimientoDescargasFichaP__c	
        TAM_SeguimientoDescargasFichaP__c	 segFichaProd = new TAM_SeguimientoDescargasFichaP__c();
        segFichaProd.TAM_FechaDescargaPDF__c =DateTime.Now();
        segFichaProd.TAM_FichaProducto__c =  id;
        try{
            insert segFichaProd;
        }catch(Exception e){
            system.debug('Error general'+e.getMessage());
        }
        
        
        //Se crea el documento de tipo Attachment dentro de Salesforce
        PageReference PDf =  Page.FichaProductoPDF;//Replace attachmentPDf with the page you have rendered as PDF
        PDf.getParameters().put('Id',id);
        PDf.setRedirect(true);
        Attachment attach = new Attachment();
        Blob b ;
        if(!test.isRunningTest()){
        	b = PDf.getContent();
        }
        attach.Body = b;
        attach.Name = 'FichaDescargada'+date.today()+id+'.pdf';
        attach.IsPrivate = false;
        attach.ParentId = segFichaProd.id;
        try{
            insert attach;
        }catch(Exception e){
            system.debug('Error general'+e.getMessage());
        }
    }
    
      //Metodo para guardar el pdf generado dentro de salesforce 
    @AuraEnabled
    public static void saveXLSFDC(String id){
        //Se crea el registro de tipo TAM_SeguimientoDescargasFichaP__c	
        TAM_SeguimientoDescargasFichaP__c	 segFichaProd = new TAM_SeguimientoDescargasFichaP__c();
        segFichaProd.TAM_FechaDescargaPDF__c =DateTime.Now();
        segFichaProd.TAM_FichaProducto__c =  id;
        try{
            insert segFichaProd;
        }catch(Exception e){
            system.debug('Error general'+e.getMessage());
        }
        
        
        //Se crea el documento de tipo Attachment dentro de Salesforce
        PageReference PDf =  Page.FichaProductoExportar;//Replace attachmentPDf with the page you have rendered as PDF
        PDf.getParameters().put('Id',id);
        PDf.setRedirect(true);
        Attachment attach = new Attachment();
        Blob b ;
        if(!test.isRunningTest()){
        	b = PDf.getContent();
        }
        attach.Body = b;
        attach.Name = 'FichaDescargada'+date.today()+id+'.xls';
        attach.IsPrivate = false;
        attach.ParentId = segFichaProd.id;
        try{
            insert attach;
        }catch(Exception e){
            system.debug('Error general'+e.getMessage());
        }
    }

    @AuraEnabled
    public static Integer countCriticalFields(String IdFichaProducto){
        Integer criticalFields = 0;

        criticalFields = [select count() from 
            EspecificacionFichaTecnica__c where FichaTecnicaProducto__c =: IdFichaProducto 
            AND (TAM_EstatusCriticalField__c = 'Pendiente Revisión (Planner)' or TAM_EstatusCriticalField__c = 'No Aprobado (Planner)')];

        try {
            return criticalFields;
        } catch (Exception e) {
            throw new AuraHandledException(e.getMessage());
        }
    }


}